"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var src_1 = require("../../src");
var memory_persistence_provider_1 = require("../../src/services/memory-persistence-provider");
var spin_wait_1 = require("../helpers/spin-wait");
var basicWorkflowScope = {
    step1Ticker: 0,
    step2Ticker: 0
};
describe("basic workflow", function () {
    var Step1 = /** @class */ (function (_super) {
        __extends(Step1, _super);
        function Step1() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Step1.prototype.run = function (context) {
            basicWorkflowScope.step1Ticker++;
            return src_1.ExecutionResult.next();
        };
        return Step1;
    }(src_1.StepBody));
    var Step2 = /** @class */ (function (_super) {
        __extends(Step2, _super);
        function Step2() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Step2.prototype.run = function (context) {
            basicWorkflowScope.step2Ticker++;
            return src_1.ExecutionResult.next();
        };
        return Step2;
    }(src_1.StepBody));
    var Basic_Workflow = /** @class */ (function () {
        function Basic_Workflow() {
            this.id = "basic-workflow";
            this.version = 1;
        }
        Basic_Workflow.prototype.build = function (builder) {
            builder
                .startWith(Step1)
                .then(Step2);
        };
        return Basic_Workflow;
    }());
    var workflowId = null;
    var instance = null;
    var persistence = new memory_persistence_provider_1.MemoryPersistenceProvider();
    var config = src_1.configureWorkflow();
    config.useLogger(new src_1.ConsoleLogger());
    config.usePersistence(persistence);
    var host = config.getHost();
    jasmine.DEFAULT_TIMEOUT_INTERVAL = 20000;
    beforeAll(function (done) { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    host.registerWorkflow(Basic_Workflow);
                    return [4 /*yield*/, host.start()];
                case 1:
                    _a.sent();
                    return [4 /*yield*/, host.startWorkflow("basic-workflow", 1, null)];
                case 2:
                    workflowId = _a.sent();
                    spin_wait_1.spinWaitCallback(function () { return __awaiter(_this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, persistence.getWorkflowInstance(workflowId)];
                                case 1:
                                    instance = _a.sent();
                                    return [2 /*return*/, (instance.status != src_1.WorkflowStatus.Runnable)];
                            }
                        });
                    }); }, done);
                    return [2 /*return*/];
            }
        });
    }); });
    afterAll(function () {
        host.stop();
    });
    it("should have an id", function () {
        expect(workflowId).toBeDefined();
    });
    it("should be marked as complete", function () {
        expect(instance.status).toBe(src_1.WorkflowStatus.Complete);
    });
    it("should have executed step 1 once", function () {
        expect(basicWorkflowScope.step1Ticker).toBe(1);
    });
    it("should have executed step 2 once", function () {
        expect(basicWorkflowScope.step2Ticker).toBe(1);
    });
});
//# sourceMappingURL=basic-workflow.spec.js.map