import { StepBody, InlineStepBody } from "../abstractions";
import { StepOutcome, StepExecutionContext, ExecutionResult } from "../models";
import { StepBuilder } from "./step-builder";
import { WorkflowBuilder } from "./workflow-builder";
export declare class OutcomeBuilder<TData> {
    private workflowBuilder;
    private outcome;
    constructor(workflowBuilder: WorkflowBuilder<TData>, outcome: StepOutcome);
    then<TNewStepBody extends StepBody>(body: {
        new (): TNewStepBody;
    }, setup?: (step: StepBuilder<TNewStepBody, TData>) => void): StepBuilder<TNewStepBody, TData>;
    thenStep<TNewStepBody extends StepBody>(newStep: StepBuilder<TNewStepBody, TData>): StepBuilder<TNewStepBody, TData>;
    thenRun(step: (context: StepExecutionContext) => Promise<ExecutionResult>): StepBuilder<InlineStepBody, TData>;
}
