"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var abstractions_1 = require("../abstractions");
var models_1 = require("../models");
var step_builder_1 = require("./step-builder");
var OutcomeBuilder = /** @class */ (function () {
    function OutcomeBuilder(workflowBuilder, outcome) {
        this.workflowBuilder = workflowBuilder;
        this.outcome = outcome;
    }
    OutcomeBuilder.prototype.then = function (body, setup) {
        if (setup === void 0) { setup = null; }
        var newStep = new models_1.WorkflowStep();
        newStep.body = body;
        this.workflowBuilder.addStep(newStep);
        var stepBuilder = new step_builder_1.StepBuilder(this.workflowBuilder, newStep);
        //setup
        if (setup) {
            setup(stepBuilder);
        }
        this.outcome.nextStep = newStep.id;
        return stepBuilder;
    };
    OutcomeBuilder.prototype.thenStep = function (newStep) {
        this.outcome.nextStep = newStep.step.id;
        return newStep;
    };
    OutcomeBuilder.prototype.thenRun = function (step) {
        var newStep = new models_1.WorkflowStep();
        var bodyClass = /** @class */ (function (_super) {
            __extends(bodyClass, _super);
            function bodyClass() {
                return _super.call(this, step) || this;
            }
            return bodyClass;
        }(abstractions_1.InlineStepBody));
        ;
        newStep.body = bodyClass;
        this.workflowBuilder.addStep(newStep);
        var stepBuilder = new step_builder_1.StepBuilder(this.workflowBuilder, newStep);
        this.outcome.nextStep = newStep.id;
        return stepBuilder;
    };
    return OutcomeBuilder;
}());
exports.OutcomeBuilder = OutcomeBuilder;
//# sourceMappingURL=outcome-builder.js.map