import { StepBody } from "../abstractions";
import { WorkflowDefinition, WorkflowStepBase } from "../models";
import { StepBuilder } from "./step-builder";
export declare class WorkflowBuilder<TData> {
    private steps;
    errorBehavior: number;
    retryInterval: number;
    build(id: string, version: number): WorkflowDefinition;
    addStep(step: WorkflowStepBase): void;
    startWith<TNewStepBody extends StepBody>(body: {
        new (): TNewStepBody;
    }, setup?: (step: StepBuilder<TNewStepBody, TData>) => void): StepBuilder<TNewStepBody, TData>;
    getUpstreamSteps(id: number): Array<WorkflowStepBase>;
    lastStep(): number;
}
