"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var models_1 = require("../models");
var container_step_body_1 = require("./container-step-body");
var Schedule = /** @class */ (function (_super) {
    __extends(Schedule, _super);
    function Schedule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Schedule.prototype.run = function (context) {
        var next = new Date(new Date().getTime() + this.interval);
        if (!context.persistenceData) {
            var data = new models_1.SchedulePersistenceData();
            data.elapsed = false;
            return models_1.ExecutionResult.sleep(next, data);
        }
        if (!context.persistenceData.elapsed) {
            var data = new models_1.SchedulePersistenceData();
            data.elapsed = true;
            return models_1.ExecutionResult.branch([null], data);
        }
        var complete = true;
        for (var _i = 0, _a = context.pointer.children; _i < _a.length; _i++) {
            var childId = _a[_i];
            complete = complete && this.isBranchComplete(context.workflow.executionPointers, childId);
        }
        if (complete)
            return models_1.ExecutionResult.next();
        return models_1.ExecutionResult.persist(context.persistenceData);
    };
    return Schedule;
}(container_step_body_1.ContainerStepBody));
exports.Schedule = Schedule;
//# sourceMappingURL=schedule.js.map