"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var models_1 = require("../models");
var ExecutionPointerFactory = /** @class */ (function () {
    function ExecutionPointerFactory() {
    }
    ExecutionPointerFactory.prototype.buildGenesisPointer = function (defintion) {
        var result = new models_1.ExecutionPointer();
        result.active = true;
        result.stepId = 0;
        result.status = models_1.PointerStatus.Pending;
        result.id = this.generatePointerId();
        return result;
    };
    ExecutionPointerFactory.prototype.buildNextPointer = function (pointer, outcomeTarget) {
        var result = new models_1.ExecutionPointer();
        result.active = true;
        result.stepId = outcomeTarget.nextStep;
        result.status = models_1.PointerStatus.Pending;
        result.id = this.generatePointerId();
        result.predecessorId = pointer.id;
        result.contextItem = pointer.contextItem;
        if (pointer.scope)
            result.scope = pointer.scope.slice();
        return result;
    };
    ExecutionPointerFactory.prototype.buildChildPointer = function (pointer, childId, branch) {
        var result = new models_1.ExecutionPointer();
        result.active = true;
        result.id = this.generatePointerId();
        result.predecessorId = pointer.id;
        result.status = models_1.PointerStatus.Pending;
        result.stepId = childId;
        result.contextItem = branch;
        if (pointer.scope)
            result.scope = pointer.scope.slice();
        result.scope.push(pointer.id);
        pointer.children.push(result.id);
        return result;
    };
    ExecutionPointerFactory.prototype.buildCompensationPointer = function (pointer, exceptionPointer, compensationStepId) {
        var result = new models_1.ExecutionPointer();
        result.active = true;
        result.predecessorId = exceptionPointer.id;
        result.stepId = compensationStepId,
            result.status = models_1.PointerStatus.Pending;
        result.id = this.generatePointerId();
        result.contextItem = pointer.contextItem;
        if (pointer.scope)
            result.scope = pointer.scope.slice();
        return result;
    };
    ExecutionPointerFactory.prototype.generatePointerId = function () {
        return (Math.random() * 0x10000000000000).toString(16);
    };
    ExecutionPointerFactory = __decorate([
        inversify_1.injectable()
    ], ExecutionPointerFactory);
    return ExecutionPointerFactory;
}());
exports.ExecutionPointerFactory = ExecutionPointerFactory;
//# sourceMappingURL=execution-pointer-factory.js.map