import { IExecutionResultProcessor } from "../abstractions";
import { WorkflowInstance, ExecutionPointer, ExecutionResult, WorkflowDefinition, WorkflowStepBase, WorkflowExecutorResult } from "../models";
export declare class ExecutionResultProcessor implements IExecutionResultProcessor {
    private pointerFactory;
    private logger;
    processExecutionResult(stepResult: ExecutionResult, pointer: ExecutionPointer, instance: WorkflowInstance, step: WorkflowStepBase, workflowResult: WorkflowExecutorResult): void;
    handleStepException(workflow: WorkflowInstance, definition: WorkflowDefinition, pointer: ExecutionPointer, step: WorkflowStepBase): void;
    private selectErrorStrategy(errorOption, workflow, definition, pointer, step);
    private compensate(workflow, definition, exceptionPointer);
    private shouldCompensate(workflow, definition, currentPointer);
    private isNull(obj, fallback);
}
