"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var abstractions_1 = require("../abstractions");
var models_1 = require("../models");
var WorkflowExecutor = /** @class */ (function () {
    function WorkflowExecutor() {
    }
    WorkflowExecutor.prototype.execute = function (instance) {
        return __awaiter(this, void 0, void 0, function () {
            var result, exePointers, def, _loop_1, this_1, _i, exePointers_1, pointer;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        result = new models_1.WorkflowExecutorResult();
                        this.logger.log("Execute workflow: " + instance.id);
                        exePointers = instance.executionPointers.filter(function (x) { return x.active; });
                        def = this.registry.getDefinition(instance.workflowDefinitionId, instance.version);
                        if (!def) {
                            throw "No workflow definition in registry for " + instance.workflowDefinitionId + ":" + instance.version;
                        }
                        _loop_1 = function (pointer) {
                            var step, stepContext, body, _i, _a, input, stepResult, _b, _c, output, err_1, perr;
                            return __generator(this, function (_d) {
                                switch (_d.label) {
                                    case 0:
                                        step = def.steps.find(function (x) { return x.id == pointer.stepId; });
                                        if (!step) return [3 /*break*/, 5];
                                        _d.label = 1;
                                    case 1:
                                        _d.trys.push([1, 3, , 4]);
                                        pointer.status = models_1.PointerStatus.Running;
                                        switch (step.initForExecution(result, def, instance, pointer)) {
                                            case models_1.ExecutionPipelineDirective.Defer: return [2 /*return*/, "continue"];
                                            case models_1.ExecutionPipelineDirective.EndWorkflow:
                                                instance.status = models_1.WorkflowStatus.Complete;
                                                instance.completeTime = new Date();
                                                return [2 /*return*/, "continue"];
                                        }
                                        if (!pointer.startTime)
                                            pointer.startTime = new Date();
                                        stepContext = new models_1.StepExecutionContext();
                                        stepContext.persistenceData = pointer.persistenceData;
                                        stepContext.step = step;
                                        stepContext.workflow = instance;
                                        stepContext.item = pointer.contextItem;
                                        stepContext.pointer = pointer;
                                        body = this_1.container.resolve(step.body);
                                        //inputs
                                        for (_i = 0, _a = step.inputs; _i < _a.length; _i++) {
                                            input = _a[_i];
                                            input(body, instance.data);
                                        }
                                        switch (step.beforeExecute(result, stepContext, pointer, body)) {
                                            case models_1.ExecutionPipelineDirective.Defer: return [2 /*return*/, "continue"];
                                            case models_1.ExecutionPipelineDirective.EndWorkflow:
                                                instance.status = models_1.WorkflowStatus.Complete;
                                                instance.completeTime = new Date();
                                                return [2 /*return*/, "continue"];
                                        }
                                        return [4 /*yield*/, body.run(stepContext)];
                                    case 2:
                                        stepResult = _d.sent();
                                        //outputs
                                        for (_b = 0, _c = step.outputs; _b < _c.length; _b++) {
                                            output = _c[_b];
                                            output(body, instance.data);
                                        }
                                        this_1.resultProcessor.processExecutionResult(stepResult, pointer, instance, step, result);
                                        return [3 /*break*/, 4];
                                    case 3:
                                        err_1 = _d.sent();
                                        this_1.logger.error("Error executing workflow %s on step %s - %o", instance.id, pointer.stepId, err_1);
                                        perr = new models_1.ExecutionError();
                                        perr.message = err_1.message;
                                        perr.errorTime = new Date();
                                        result.errors.push(perr);
                                        this_1.resultProcessor.handleStepException(instance, def, pointer, step);
                                        return [3 /*break*/, 4];
                                    case 4: return [3 /*break*/, 6];
                                    case 5:
                                        this_1.logger.error("Could not find step on workflow %s %s", instance.id, pointer.stepId);
                                        pointer.sleepUntil = (Date.now() + 60000); //todo: make configurable
                                        _d.label = 6;
                                    case 6: return [2 /*return*/];
                                }
                            });
                        };
                        this_1 = this;
                        _i = 0, exePointers_1 = exePointers;
                        _a.label = 1;
                    case 1:
                        if (!(_i < exePointers_1.length)) return [3 /*break*/, 4];
                        pointer = exePointers_1[_i];
                        return [5 /*yield**/, _loop_1(pointer)];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4:
                        this.processAfterExecutionIteration(instance, def, result);
                        this.determineNextExecutionTime(instance);
                        return [2 /*return*/, result];
                }
            });
        });
    };
    WorkflowExecutor.prototype.processAfterExecutionIteration = function (workflow, defintion, workflowResult) {
        var pointers = workflow.executionPointers.filter(function (x) { return !x.endTime; });
        var _loop_2 = function (pointer) {
            var step = defintion.steps.find(function (x) { return x.id == pointer.stepId; });
            if (step)
                step.afterWorkflowIteration(workflowResult, defintion, workflow, pointer);
        };
        for (var _i = 0, pointers_1 = pointers; _i < pointers_1.length; _i++) {
            var pointer = pointers_1[_i];
            _loop_2(pointer);
        }
    };
    WorkflowExecutor.prototype.determineNextExecutionTime = function (instance) {
        instance.nextExecution = null;
        if (instance.status == models_1.WorkflowStatus.Complete)
            return;
        for (var _i = 0, _a = instance.executionPointers.filter(function (x) { return x.active && x.children.length == 0; }); _i < _a.length; _i++) {
            var pointer = _a[_i];
            if (!pointer.sleepUntil) {
                instance.nextExecution = 0;
                return;
            }
            instance.nextExecution = Math.min(pointer.sleepUntil, instance.nextExecution ? instance.nextExecution : pointer.sleepUntil);
        }
        if (instance.nextExecution === null) {
            var _loop_3 = function (pointer) {
                if (!instance.executionPointers.filter(function (x) { return x.scope.includes(pointer.id); }).every(function (x) { return !!x.endTime; }))
                    return "continue";
                if (!pointer.sleepUntil) {
                    instance.nextExecution = 0;
                    return { value: void 0 };
                }
                instance.nextExecution = Math.min(pointer.sleepUntil, instance.nextExecution ? instance.nextExecution : pointer.sleepUntil);
            };
            for (var _b = 0, _c = instance.executionPointers.filter(function (x) { return x.active && x.children.length > 0; }); _b < _c.length; _b++) {
                var pointer = _c[_b];
                var state_1 = _loop_3(pointer);
                if (typeof state_1 === "object")
                    return state_1.value;
            }
        }
        if ((instance.nextExecution === null) && (instance.executionPointers.every(function (x) { return Boolean(x.endTime); }))) {
            instance.completeTime = new Date();
            instance.status = models_1.WorkflowStatus.Complete;
        }
    };
    __decorate([
        inversify_1.inject(abstractions_1.TYPES.IWorkflowRegistry),
        __metadata("design:type", Object)
    ], WorkflowExecutor.prototype, "registry", void 0);
    __decorate([
        inversify_1.inject(abstractions_1.TYPES.IExecutionResultProcessor),
        __metadata("design:type", Object)
    ], WorkflowExecutor.prototype, "resultProcessor", void 0);
    __decorate([
        inversify_1.inject(abstractions_1.TYPES.ILogger),
        __metadata("design:type", Object)
    ], WorkflowExecutor.prototype, "logger", void 0);
    __decorate([
        inversify_1.inject(inversify_1.Container),
        __metadata("design:type", inversify_1.Container)
    ], WorkflowExecutor.prototype, "container", void 0);
    WorkflowExecutor = __decorate([
        inversify_1.injectable()
    ], WorkflowExecutor);
    return WorkflowExecutor;
}());
exports.WorkflowExecutor = WorkflowExecutor;
//# sourceMappingURL=workflow-executor.js.map